<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scheduling_mail_ehr_patient".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SchedulingMailEhrPatient".
 *
 * Columns in table "scheduling_mail_ehr_patient" available as properties of the model,
 * followed by relations of table "scheduling_mail_ehr_patient" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_emr_id
 * @property string $scheduling_mail_id
 * @property integer $ehr_patient_id
 * @property string $first_name
 * @property string $middle_name
 * @property string $last_name
 * @property string $phone_number
 * @property string $email
 * @property string $date_birth
 *
 * @property AccountEmr $accountEmr
 * @property SchedulingMail $schedulingMail
 */
abstract class BaseSchedulingMailEhrPatient extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scheduling_mail_ehr_patient';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'SchedulingMailEhrPatient|SchedulingMailEhrPatients', $n);
    }

    public static function representingColumn()
    {
        return 'first_name';
    }

    public function rules()
    {
        return array(
            array('account_emr_id, scheduling_mail_id, ehr_patient_id, first_name, last_name', 'required'),
            array('account_emr_id, ehr_patient_id', 'numerical', 'integerOnly' => true),
            array('scheduling_mail_id', 'length', 'max' => 10),
            array('first_name', 'length', 'max' => 50),
            array('middle_name', 'length', 'max' => 20),
            array('last_name', 'length', 'max' => 80),
            array('phone_number', 'length', 'max' => 14),
            array('email', 'length', 'max' => 254),
            array('date_birth', 'safe'),
            array('middle_name, phone_number, email, date_birth', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, account_emr_id, scheduling_mail_id, ehr_patient_id, first_name, middle_name, last_name, phone_number, email, date_birth', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'accountEmr' => array(self::BELONGS_TO, 'AccountEmr', 'account_emr_id'),
            'schedulingMail' => array(self::BELONGS_TO, 'SchedulingMail', 'scheduling_mail_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_emr_id' => null,
            'scheduling_mail_id' => null,
            'ehr_patient_id' => Yii::t('app', 'Ehr Patient'),
            'first_name' => Yii::t('app', 'First Name'),
            'middle_name' => Yii::t('app', 'Middle Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'email' => Yii::t('app', 'Email'),
            'date_birth' => Yii::t('app', 'Date Birth'),
            'accountEmr' => null,
            'schedulingMail' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_emr_id', $this->account_emr_id);
        $criteria->compare('scheduling_mail_id', $this->scheduling_mail_id);
        $criteria->compare('ehr_patient_id', $this->ehr_patient_id);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('middle_name', $this->middle_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('date_birth', $this->date_birth, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
